#!/usr/bin/perl

#########################################################
# UMPL xmail
# update V 2.9 to 2.10
# (c) 16.11.2003 waaf.net computing
# Achim Schmidt schmidt@waaf.net
#########################################################

$doc_root = "/home/umpl_xmail";
$auspfad2 = "umpl_xmail_update.sh";


($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst)=localtime(time);
$timestamp = sprintf ("%4d-%02d-%02d_%02d-%02d-%02d\n",$year+1900,$mon+1,$mday,$hour,$min,$sec);
chop($timestamp );


sub clear_the_screen {
	print "\e[2J";
	system(($^O eq 'MSWin32') ? 'cls' : 'clear');
}
sub raus {
	print "\nNothing has been changed - bye!\n";
	exit;
}
sub mach_sicherheitskopie {
	local ($pfad, $ext, $selber) = @_;
	my $befehl = "cp $doc_root/$pfad $doc_root/$pfad.BACKUP_29to210.$timestamp.$ext";
	print "$befehl \n";
	if($selber eq "No"){
	  system("$befehl");
	}
	if($selber eq "Yes"){
	 open (FILE,">>$auspfad") || die "Could not write to textfile";
	  print FILE "$befehl\n";
  	 close (FILE);
	}
}
sub kopiere_neue_datei {
	local ($pfad, $selber) = @_;
	my $befehl = "cp $pfad $doc_root/$pfad";
	print "$befehl \n";
	if($selber eq "No"){
	 system("$befehl");
	}
	if($selber eq "Yes"){
	 open (FILE,">>$auspfad") || die "Could not write to textfile";
	  print FILE "$befehl\n";
  	 close (FILE);
	}
}
sub weitermachen {
	print "Please press <ENTER> to succeed or press 'X' to exit! \n";
	$weiter = <STDIN>;
	chop($weiter);
	if($weiter eq "X"){ raus(); }
	if($weiter eq "x"){ raus(); }
	if($weiter eq "exit"){ raus(); }
	if($weiter eq "Exit"){ raus(); }

}
sub change_mod_755 {
        local ($pfad, $selber) = @_;
        my $befehl = "chmod 777 $doc_root/$pfad";
        print "$befehl \n";
        if($selber eq "No"){
         if(system($befehl)) { print "chmod failed\n"; }
        }
        if($selber eq "Yes"){
         open (FILE,">>$auspfad") || die "Could not write to textfile";
          print FILE "$befehl\n";
         close (FILE);
        }
}
sub mach_dir {
        local ($pfad, $selber) = @_;
        my $befehl = "mkdir $doc_root/$pfad";
        print "$befehl \n";
        if($selber eq "No"){
         if(system($befehl)) { print "mkdir failed\n"; }
        }
        if($selber eq "Yes"){
         open (FILE,">>$auspfad") || die "Could not write to textfile";
          print FILE "$befehl\n";
         close (FILE);
        }
}
sub change_dir_777 {
        local ($pfad, $selber) = @_;
        my $befehl = "chmod 777 $doc_root/$pfad";
        print "$befehl \n";
        if($selber eq "No"){
         if(system($befehl)) { print "chmod failed\n"; }
        }
        if($selber eq "Yes"){
         open (FILE,">>$auspfad") || die "Could not write to textfile";
          print FILE "$befehl\n";
         close (FILE);
        }
}



# close STDERR;


clear_the_screen();

print "------------------------------------------------------\n";
print "|     UMPL Xmail   -   Upgrade from V 2.9 to 2.10    |\n";
print "------------------------------------------------------\n\n";

print "Nothing will be done until all questions are answered!\n";
print "All commands can be done by the script or manually by \n";
print "yourself !\n\n";
print "------------------------------------------------------\n\n";
print "Please enter the location of your UMPL Xmail installa-\n";
print "tion (Not MAIL_ROOT) or press <ENTER> for the default \n";
print "value: [$doc_root] > ";
$doc_root2 = <STDIN>;
chop($doc_root2);
if($doc_root2 ne ""){ $doc_root = $doc_root2; }
print "\n";


print "Do you want to copy the new files and rename the old  \n";
print "by yourself? [No] > ";
$selber = <STDIN>;
chop($selber);
if($selber eq ""){ $selber="No"; }
if($selber eq "N"){ $selber="No"; }
if($selber eq "NO"){ $selber="No"; }
if($selber eq "no"){ $selber="No"; }
if($selber eq "nein"){ $selber="No"; }
if($selber eq "Nein"){ $selber="No"; }
if($selber eq "n"){ $selber="No"; }
if($selber eq "Y"){ $selber="Yes"; }
if($selber eq "YES"){ $selber="Yes"; }
if($selber eq "Yes"){ $selber="Yes"; }
if($selber eq "yes"){ $selber="Yes"; }
if($selber eq "y"){ $selber="Yes"; }
if($selber eq "j"){ $selber="Yes"; }
if($selber eq "ja"){ $selber="Yes"; }
if($selber eq "J"){ $selber="Yes"; }
if($selber eq "Ja"){ $selber="Yes"; }
if( ($selber ne "Yes") && ($selber ne "No") ) {
	raus();
}

print "\n";
##########################################################
# schauen, ob der pfad vom doc_root nen slash am ende hat
# und wenn ja, dann abschneiden...
##########################################################
$letzer_bs = substr($doc_root,-1,1);
if($letzer_bs eq "/"){
 $doc_root = substr($doc_root,0,-1);
}

print "------------------------------------------------------\n\n";
print "lets have a look ....\n";
# opendir DIRHANDLE,EXPR
opendir ($test_dir,$doc_root) || die "\n------------------------------------------------------\n[ERROR]\n" .
			"Sorry - It seems that you gave a wrong doc_root.\n" .
			"The directory $doc_root does not exist!\n\n" .
			"Nothing has been changed - bye! \n";
closedir($test_dir);

################################################
$__befehl = "grep \"VERSION\" $doc_root/inc/seite.class.php";
$_ret = `$__befehl`;
print "Version installed: $_ret";
################################################

if($_ret eq ""){
	print "\n------------------------------------------------------\n[ERROR]\n";
	print "Sorry - It seems that you gave the wrong doc_root.\n";
	print "The file $doc_root/inc/seite.class.php does \n";
	print "not exist OR has been modified by yourself - Better.\n";
	print "upgrade by hand!\n";
	
	print "Do you really want to succeed? [No] > ";
	$selber2 = <STDIN>;
	chop($selber2);
	if($selber2 eq ""){ $selber2="No"; }
	if($selber2 eq "N"){ $selber2="No"; }
	if($selber2 eq "NO"){ $selber2="No"; }
	if($selber2 eq "no"){ $selber2="No"; }
	if($selber2 eq "nein"){ $selber2="No"; }
	if($selber2 eq "Nein"){ $selber2="No"; }
	if($selber2 eq "n"){ $selber2="No"; }
	if($selber2 eq "Y"){ $selber2="Yes"; }
	if($selber2 eq "YES"){ $selber2="Yes"; }
	if($selber2 eq "Yes"){ $selber2="Yes"; }
	if($selber2 eq "yes"){ $selber2="Yes"; }
	if($selber2 eq "y"){ $selber2="Yes"; }
	if($selber2 eq "j"){ $selber2="Yes"; }
	if($selber2 eq "ja"){ $selber2="Yes"; }
	if($selber2 eq "J"){ $selber2="Yes"; }
	if($selber2 eq "Ja"){ $selber2="Yes"; }
	if($selber2 ne "Yes") {
		raus();
	}
}
print "\n";
print "Okay - now we are ready to start...\n";
weitermachen();


if($selber eq "Yes"){

print "Give a name for the textfile where all commands are stored? \n".
"[$auspfad2] > ";
	$auspfad = <STDIN>;
	chop($auspfad);
if($auspfad eq ""){ $auspfad = $auspfad2; }
print "\nOutput will be stored to $auspfad.\n";
 	open (FILE,">$auspfad") || die "Could not create textfile!\n\nNothing done!\n...bye";
	  print FILE "$befehl\n";
  	 close (FILE);

	weitermachen();
}






print "------------------------------------------------------\n";
print "Making backups of existing files: \n";
mach_sicherheitskopie("index.php", "php", $selber);
mach_sicherheitskopie("inbox.php", "php", $selber);
mach_sicherheitskopie("root_user.php", "php", $selber);
mach_sicherheitskopie("uservars.php", "php", $selber);
mach_sicherheitskopie("banned_from.php", "php", $selber);
mach_sicherheitskopie("forward.php", "php", $selber);
mach_sicherheitskopie("mail_forward.php", "php", $selber);
mach_sicherheitskopie("reply.php", "php", $selber);
mach_sicherheitskopie("sendmail.php", "php", $selber);
mach_sicherheitskopie("uservars.php", "php", $selber);

mach_sicherheitskopie("inc/seite.class.php", "php", $selber);
mach_sicherheitskopie("inc/class.php", "php", $selber);
mach_sicherheitskopie("inc/email_message.php", "php", $selber);
mach_sicherheitskopie("inc/hildegard.class.php", "php", $selber);


mach_sicherheitskopie("root/seite.class.php", "php", $selber);
mach_sicherheitskopie("root/class.php", "php", $selber);
mach_sicherheitskopie("root/index.php", "php", $selber);

mach_sicherheitskopie("inc/language.de.php", "php", $selber);
mach_sicherheitskopie("inc/language.en.php", "php", $selber);
mach_sicherheitskopie("inc/language.fr.php", "php", $selber);
mach_sicherheitskopie("inc/language.hu.php", "php", $selber);
mach_sicherheitskopie("inc/language.it.php", "php", $selber);
mach_sicherheitskopie("inc/language.nl.php", "php", $selber);
mach_sicherheitskopie("inc/language.pl.php", "php", $selber);
mach_sicherheitskopie("inc/language.ru.php", "php", $selber);
mach_sicherheitskopie("inc/language.sl.php", "php", $selber);
mach_sicherheitskopie("inc/language.sp.php", "php", $selber);
mach_sicherheitskopie("inc/language.tr.php", "php", $selber);


print "[DONE]\n\n";
print "------------------------------------------------------\n";
print "Copying new files: \n";


kopiere_neue_datei("index.php", $selber);
kopiere_neue_datei("inbox.php", $selber);
kopiere_neue_datei("uservars.php", $selber);
kopiere_neue_datei("banned_from.php", $selber);
kopiere_neue_datei("forward.php", $selber);
kopiere_neue_datei("mail_forward.php", $selber);
kopiere_neue_datei("reply.php", $selber);
kopiere_neue_datei("sendmail.php", $selber);
kopiere_neue_datei("userreply.php", $selber);

kopiere_neue_datei("autoreply.sh", $selber);
mach_dir("autoreply", $selber);
change_dir_777("autoreply", $selber);


kopiere_neue_datei("inc/seite.class.php", $selber);
kopiere_neue_datei("inc/class.php", $selber);
kopiere_neue_datei("inc/email_message.php",  $selber);
kopiere_neue_datei("inc/hildegard.class.php", $selber);

kopiere_neue_datei("root/index.php", $selber);
kopiere_neue_datei("root/seite.class.php", $selber);
kopiere_neue_datei("root/class.php", $selber);

kopiere_neue_datei("inc/language.de.php", $selber);
kopiere_neue_datei("inc/language.en.php", $selber);
kopiere_neue_datei("inc/language.fr.php", $selber);
kopiere_neue_datei("inc/language.hu.php", $selber);
kopiere_neue_datei("inc/language.it.php", $selber);
kopiere_neue_datei("inc/language.nl.php", $selber);
kopiere_neue_datei("inc/language.pl.php", $selber);
kopiere_neue_datei("inc/language.ru.php", $selber);
kopiere_neue_datei("inc/language.sl.php", $selber);
kopiere_neue_datei("inc/language.sp.php", $selber);
kopiere_neue_datei("inc/language.sv.php", $selber);
kopiere_neue_datei("inc/language.tr.php", $selber);


kopiere_neue_datei("inc/credits.txt", $selber);



print "[DONE]\n\n";
print "------------------------------------------------------\n";
print "Updating Database: \n";
print "... nothing to do for update from 2.9 to 2.10!\n";
print "[DONE]\n\n";
print "------------------------------------------------------\n";
print "Update done Successfully!\n";

if($selber eq "No"){
	print "All files, that have been changed can be found at: \n";
	print "  $doc_root/FILENAME.BACKUP_29to210.$timestamp\n";
} else {
	print "\n\nRUN $auspfad to finish the update!!!";
}

print "\n\n\n";
print "Thanks for using umpl for xmailserver!\n";
print "Check for updates: http://umpl.de/\n";

